! -------------------------------------------
! TPPM decoupling routines
! -------------------------------------------
DEFINE USE_TPPM_PARAMS
	.long					cyclesPM	= 8;			!# of TPPM cycles
	.time	extern	autofix		pwPM		= 3us;
	.time					tPMloop		= 3us;
	.phase	extern			p2			=  30;			!Hdec phase excursion
	.phase	autofix		PMphase1		= 0.;
	.phase	autofix		PMphase2		= 180.;
	.ampl	extern			aPM			= 0.1;
ENDDEF

! can be use in program part only
DEFINE CALC_TPPM_DEC(DEC_TIME,DEC_PHASE)
	cyclesPM = floor ((DEC_TIME)/(pwPM*2.));
	PMphase1 = 90. + ((DEC_PHASE)/2.);
	PMphase2 = 90. - ((DEC_PHASE)/2.);
	tPMloop=2.*pwPM;

ENDDEF

! tPMloop must be defined with CALC_TPPM_DEC first
DEFINE CALC_TPPM_CYCLES(DEC_TIME,CYCLES)
	CYCLES = floor ((DEC_TIME)/(tPMloop));
ENDDEF

DEFINE RUN_TPPM_DEC(uch,CYCLES)
	do(CYCLES) {
		out	pwPM	uch: TG|OUTP PMphase1 ;
		out	pwPM	uch: TG|OUTP PMphase2 ;
	}
ENDDEF

! -------------------------------------------
! end of TPPM decoupling routines
! -------------------------------------------
